
#pragma once

class CDonutSecurityZone
{
// Message map and handlers
	BEGIN_MSG_MAP(CDonutSecurityZone)
		COMMAND_ID_HANDLER_EX(ID_URLACTION_SCRIPT_RUN, OnUrlActionScriptRun)
		COMMAND_ID_HANDLER_EX(ID_URLACTION_JAVA_PERMISSIONS, OnUrlActionJavaPermissions)

		COMMAND_ID_HANDLER_EX(ID_URLACTION_DOWNLOAD_SIGNED_ACTIVEX, OnUrlActionDownloadSignedActiveX)
		COMMAND_ID_HANDLER_EX(ID_URLACTION_ACTIVEX_RUN, OnUrlActionActiveXRun)

		COMMAND_ID_HANDLER_EX(ID_URLACTION_COOKIES, OnUrlActionCookies)
		COMMAND_ID_HANDLER_EX(ID_URLACTION_COOKIES_SESSION, OnUrlActionCookiesSession)
	END_MSG_MAP()

	void OnUrlActionScriptRun(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		MtlSetInternetZoneActionPolicy(URLACTION_SCRIPT_RUN, 
			MtlIsInternetZoneActionPolicyDisallow(URLACTION_SCRIPT_RUN) ? URLPOLICY_ALLOW : URLPOLICY_DISALLOW);
	}
	void OnUrlActionJavaPermissions(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		DWORD dwPolicy;
		if (MtlGetInternetZoneActionPolicy(URLACTION_JAVA_PERMISSIONS) != URLPOLICY_JAVA_PROHIBIT)
			dwPolicy = URLPOLICY_JAVA_PROHIBIT;
		else
			dwPolicy = URLPOLICY_JAVA_HIGH;

		MtlSetInternetZoneActionPolicy(URLACTION_JAVA_PERMISSIONS, dwPolicy);
	}

	void OnUrlActionDownloadSignedActiveX(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		DWORD dwPolicy;
		if (MtlGetInternetZoneActionPolicy(URLACTION_DOWNLOAD_SIGNED_ACTIVEX) != URLPOLICY_QUERY)
			dwPolicy = URLPOLICY_QUERY;// recommanded
		else
			dwPolicy = URLPOLICY_DISALLOW;

		MtlSetInternetZoneActionPolicy(URLACTION_DOWNLOAD_SIGNED_ACTIVEX, dwPolicy);
	}
	void OnUrlActionActiveXRun(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		MtlSetInternetZoneActionPolicy(URLACTION_ACTIVEX_RUN, 
			MtlIsInternetZoneActionPolicyDisallow(URLACTION_ACTIVEX_RUN) ? URLPOLICY_ALLOW : URLPOLICY_DISALLOW);
	}

	void OnUrlActionCookies(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		MtlSetInternetZoneActionPolicy(URLACTION_COOKIES, 
			MtlIsInternetZoneActionPolicyDisallow(URLACTION_COOKIES) ? URLPOLICY_ALLOW : URLPOLICY_DISALLOW);
	}
	void OnUrlActionCookiesSession(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		MtlSetInternetZoneActionPolicy(URLACTION_COOKIES_SESSION, 
			MtlIsInternetZoneActionPolicyDisallow(URLACTION_COOKIES_SESSION) ? URLPOLICY_ALLOW : URLPOLICY_DISALLOW);
	}

// Update command UI and handlers
	BEGIN_UPDATE_COMMAND_UI_MAP(CDonutSecurityZone)
		UPDATE_COMMAND_UI_SETCHECK_IF(ID_URLACTION_SCRIPT_RUN, !MtlIsInternetZoneActionPolicyDisallow(URLACTION_SCRIPT_RUN))
		UPDATE_COMMAND_UI_SETCHECK_IF(ID_URLACTION_JAVA_PERMISSIONS, MtlGetInternetZoneActionPolicy(URLACTION_JAVA_PERMISSIONS) != URLPOLICY_JAVA_PROHIBIT)

		UPDATE_COMMAND_UI_SETCHECK_IF(ID_URLACTION_DOWNLOAD_SIGNED_ACTIVEX, !MtlIsInternetZoneActionPolicyDisallow(URLACTION_DOWNLOAD_SIGNED_ACTIVEX))
		UPDATE_COMMAND_UI_SETCHECK_IF(ID_URLACTION_ACTIVEX_RUN, !MtlIsInternetZoneActionPolicyDisallow(URLACTION_ACTIVEX_RUN))

		UPDATE_COMMAND_UI_SETCHECK_IF(ID_URLACTION_COOKIES, !MtlIsInternetZoneActionPolicyDisallow(URLACTION_COOKIES))
		UPDATE_COMMAND_UI_SETCHECK_IF(ID_URLACTION_COOKIES_SESSION, !MtlIsInternetZoneActionPolicyDisallow(URLACTION_COOKIES_SESSION))
	END_UPDATE_COMMAND_UI_MAP()

};